/*	Rutina de formatare a textului
	si de multiplexare adigitilor	
*/
#include <avr/interrupt.h>
#include <string.h>
#include <avr/pgmspace.h>

#define BUFFLEN 64
#define OVERLAP 4
#define LED PD5

void inittxt(void);
char getcharat(char pos);

//Position of scrolling text
volatile char scrollpos;
//Buffer for incoming text
volatile char text[BUFFLEN];
//Length of text
volatile int textlen;

//Initial text
char inittext[] PROGMEM="yo6pir";

//Routine to init the text subsystem
void inittxt(void) {
    int t=0;
    char c;
    //Copypaste inittext to text buffer
    do {
	c=pgm_read_byte(&inittext[t]);
	text[t++]=c;
    } while (c!=0);
    //reset textlen&scrollpos
    scrollpos=0;
    textlen=t-1;
}

//Returns the character that should be on the pos't digit position of the VFD
//according to the latest scrollpos- and text[]-contents.
//Includes an overlap of OVERLAP spaces between end and begin of scrolling text
char getcharat(char pos) {
    char c;
    int lpos=scrollpos+pos;
    if (lpos>=textlen) lpos-=textlen+OVERLAP;
    if (lpos>=textlen) lpos-=textlen+OVERLAP;
    if (lpos>=textlen) lpos-=textlen+OVERLAP;
    if (lpos<0) return ' ';
    c=text[lpos];
    if (c<32 || c>127) return ' ';
    return text[lpos];
}

//Timer interrupt which advances the scroll position by one.
ISR(TIMER1_COMPA_vect) {
    scrollpos++;
    if (scrollpos>=(textlen+OVERLAP)) scrollpos=0;
    if (textlen<11) scrollpos=0;
}

//Uart receive interrupt
/*
ISR(USART_RX_vect) { 
    static unsigned int wpos=BUFFLEN;
    unsigned char c;
    c=UDR;
    //Black text-handling magic ^_^
    if (c<32 && wpos==0) return;
    if (wpos==0) scrollpos=0;
    text[wpos]=c;
    if (wpos<BUFFLEN) wpos++;
    textlen=wpos;
    if (c==13 || c==10 || c==12) wpos=0;
    // </magic>
}
*/


